/*
Dataddo Headless BETA API

Dataddo Headless BETA API

API version: 1.0.0-beta.1
*/

// Code generated by OpenAPI Generator (https://openapi-generator.tech); DO NOT EDIT.

package customer_api

import (
	"encoding/json"
)

// checks if the JoinConditionRequest type satisfies the MappedNullable interface at compile time
var _ MappedNullable = &JoinConditionRequest{}

// JoinConditionRequest struct for JoinConditionRequest
type JoinConditionRequest struct {
	SourceColumn *string `json:"source_column,omitempty"`
	TargetColumn *string `json:"target_column,omitempty"`
}

// NewJoinConditionRequest instantiates a new JoinConditionRequest object
// This constructor will assign default values to properties that have it defined,
// and makes sure properties required by API are set, but the set of arguments
// will change when the set of required properties is changed
func NewJoinConditionRequest() *JoinConditionRequest {
	this := JoinConditionRequest{}
	return &this
}

// NewJoinConditionRequestWithDefaults instantiates a new JoinConditionRequest object
// This constructor will only assign default values to properties that have it defined,
// but it doesn't guarantee that properties required by API are set
func NewJoinConditionRequestWithDefaults() *JoinConditionRequest {
	this := JoinConditionRequest{}
	return &this
}

// GetSourceColumn returns the SourceColumn field value if set, zero value otherwise.
func (o *JoinConditionRequest) GetSourceColumn() string {
	if o == nil || IsNil(o.SourceColumn) {
		var ret string
		return ret
	}
	return *o.SourceColumn
}

// GetSourceColumnOk returns a tuple with the SourceColumn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JoinConditionRequest) GetSourceColumnOk() (*string, bool) {
	if o == nil || IsNil(o.SourceColumn) {
		return nil, false
	}
	return o.SourceColumn, true
}

// HasSourceColumn returns a boolean if a field has been set.
func (o *JoinConditionRequest) HasSourceColumn() bool {
	if o != nil && !IsNil(o.SourceColumn) {
		return true
	}

	return false
}

// SetSourceColumn gets a reference to the given string and assigns it to the SourceColumn field.
func (o *JoinConditionRequest) SetSourceColumn(v string) {
	o.SourceColumn = &v
}

// GetTargetColumn returns the TargetColumn field value if set, zero value otherwise.
func (o *JoinConditionRequest) GetTargetColumn() string {
	if o == nil || IsNil(o.TargetColumn) {
		var ret string
		return ret
	}
	return *o.TargetColumn
}

// GetTargetColumnOk returns a tuple with the TargetColumn field value if set, nil otherwise
// and a boolean to check if the value has been set.
func (o *JoinConditionRequest) GetTargetColumnOk() (*string, bool) {
	if o == nil || IsNil(o.TargetColumn) {
		return nil, false
	}
	return o.TargetColumn, true
}

// HasTargetColumn returns a boolean if a field has been set.
func (o *JoinConditionRequest) HasTargetColumn() bool {
	if o != nil && !IsNil(o.TargetColumn) {
		return true
	}

	return false
}

// SetTargetColumn gets a reference to the given string and assigns it to the TargetColumn field.
func (o *JoinConditionRequest) SetTargetColumn(v string) {
	o.TargetColumn = &v
}

func (o JoinConditionRequest) MarshalJSON() ([]byte, error) {
	toSerialize, err := o.ToMap()
	if err != nil {
		return []byte{}, err
	}
	return json.Marshal(toSerialize)
}

func (o JoinConditionRequest) ToMap() (map[string]interface{}, error) {
	toSerialize := map[string]interface{}{}
	if !IsNil(o.SourceColumn) {
		toSerialize["source_column"] = o.SourceColumn
	}
	if !IsNil(o.TargetColumn) {
		toSerialize["target_column"] = o.TargetColumn
	}
	return toSerialize, nil
}

type NullableJoinConditionRequest struct {
	value *JoinConditionRequest
	isSet bool
}

func (v NullableJoinConditionRequest) Get() *JoinConditionRequest {
	return v.value
}

func (v *NullableJoinConditionRequest) Set(val *JoinConditionRequest) {
	v.value = val
	v.isSet = true
}

func (v NullableJoinConditionRequest) IsSet() bool {
	return v.isSet
}

func (v *NullableJoinConditionRequest) Unset() {
	v.value = nil
	v.isSet = false
}

func NewNullableJoinConditionRequest(val *JoinConditionRequest) *NullableJoinConditionRequest {
	return &NullableJoinConditionRequest{value: val, isSet: true}
}

func (v NullableJoinConditionRequest) MarshalJSON() ([]byte, error) {
	return json.Marshal(v.value)
}

func (v *NullableJoinConditionRequest) UnmarshalJSON(src []byte) error {
	v.isSet = true
	return json.Unmarshal(src, &v.value)
}
